<style type="text/css">
.calendarToday { 
	font-weight: bolder; 
	font-family: "Century Gothic";
	color: #a2f90a; 
	text-decoration: none; 
	}
</style>
<script language="JavaScript">
function display(id) {
	layer = document.getElementById(id).style;					
	layer.display="block";				
}
function hide(id) {
	layer = document.getElementById(id).style;					
	layer.display="none";				
}
</script>
<?php
require_once '../library/config.php';

date_default_timezone_set('UTC');

class Calendar
{

    function Calendar()
    {
    }

    function getDayNames()
    {
        return $this->dayNames;
    }

    function setDayNames($names)
    {
        $this->dayNames = $names;
    }

    function getMonthNames()
    {
        return $this->monthNames;
    }

    function setMonthNames($names)
    {
        $this->monthNames = $names;
    }

    function getStartDay()
    {
        return $this->startDay;
    }

    function setStartDay($day)
    {
        $this->startDay = $day;
    }

    function getStartMonth()
    {
        return $this->startMonth;
    }
    
    function setStartMonth($month)
    {
        $this->startMonth = $month;
    }
    
    function getCalendarLink($month, $year)
    {
		return "?view=calendar&month=$month&year=$year"; 
    }
    
	function getEvent($d, $m, $y)
	{
		$event = "";
		$sql = "SELECT *
				FROM tbl_events
				WHERE event_day = $d
				AND event_month = $m
				AND event_year = $y";
		$res = dbQuery($sql);
		while($row = dbFetchAssoc($res)) {
			extract($row);
			$event .= "- " . ucwords($event_name) . "<br>";
			}
		return $event;
	}
	
    function getDateLink($day, $month, $year, $class)
    {
		$sql = "SELECT *
				FROM tbl_events
				WHERE event_day = $day
				AND event_month = $month
				AND event_year = $year";
		$res = dbQuery($sql);        
		if (dbNumRows($res) != 0) {		
			return "<a href=\"index.php?view=events&day=$day&month=$month&year=$year\" class=\"$class\" onMouseover=\"display($day);\" onMouseOut=\"hide($day);\">";
			} else {
			return;
			}			
    }

    function getStyle($day, $month, $year)
    {
        $eventstyle = "";		
		$sql = "SELECT *
				FROM tbl_events
				WHERE event_day = $day
				AND event_month = $month
				AND event_year = $year";
		$res = dbQuery($sql);
		if (dbNumRows($res) != 0) {
			$eventstyle = "style=\"background-color:#E6E6E6;\"";
			} 
		return $eventstyle;
    }

    function getClass($day, $month, $year)
    {
        $today = getdate(time());
		$eventclass = "";		
		$sql = "SELECT *
				FROM tbl_events
				WHERE event_day = $day
				AND event_month = $month
				AND event_year = $year";
		$res = dbQuery($sql);
		if (dbNumRows($res) != 0) {
			$eventclass = ($year == $today["year"] && $month == $today["mon"] && $day == $today["mday"]) ? "ecalendarToday" : "ecalendarDate";
			} else {
			$eventclass = ($year == $today["year"] && $month == $today["mon"] && $day == $today["mday"]) ? "calendarToday" : "calendarDate";
			}
		return $eventclass;
    }

    function getDateInfo($day, $month, $year)
    {
        $eventdate = "";		
		$sql = "SELECT *
				FROM tbl_events
				WHERE event_day = $day
				AND event_month = $month
				AND event_year = $year";
		$res = dbQuery($sql);
		if (dbNumRows($res) != 0) {
			$eventdate = "<strong>$day</strong>";
			} else {
			$eventdate = "$day";
			}
		return $eventdate;
    }    
	
	function getCurrentMonthView($month, $year)
    {
        return $this->getMonthView($month, $year);
    }

    function getMonthView($month, $year)
    {
        return $this->getMonthHTML($month, $year);
    }
    
    function getDaysInMonth($month, $year)
    {
        if ($month < 1 || $month > 12)
        {
            return 0;
        }
   
        $d = $this->daysInMonth[$month - 1];
   
        if ($month == 2)
        {      
            if ($year%4 == 0)
            {
                if ($year%100 == 0)
                {
                    if ($year%400 == 0)
                    {
                        $d = 29;
                    }
                }
                else
                {
                    $d = 29;
                }
            }
        }
    
        return $d;
    }

    function getMonthHTML($m, $y, $showYear = 1)
    {
        $s = "";
		$bold = "";
		$ebold = "";
        
        $a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];        
        
    	$daysInMonth = $this->getDaysInMonth($month, $year);
    	$date = getdate(mktime(12, 0, 0, $month, 1, $year));
    	
    	$first = $date["wday"];
    	$monthName = $this->monthNames[$month - 1];
    	
    	$prev = $this->adjustDate($month - 1, $year);
    	$next = $this->adjustDate($month + 1, $year);
    	
    	if ($showYear == 1)
    	{
    	    $prevMonth = $this->getCalendarLink($prev[0], $prev[1]);
    	    $nextMonth = $this->getCalendarLink($next[0], $next[1]);
    	}
    	else
    	{
    	    $prevMonth = "";
    	    $nextMonth = "";
    	}
    	
    	$header = $monthName . (($showYear > 0) ? " " . $year : "");
    	
    	$s .= "<table class=\"calendar\" align=\"center\" cellpadding=\"2\" cellspacing=\"1\" width=\"50\">\n";
    	$s .= "<tr>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" height=\"30\" width=\"80\">" . (($prevMonth == "") ? "&nbsp;" : "<a class=\"textlink\" href=\"$prevMonth\">&lt;&lt;&nbsp;</a>")  . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" colspan=\"5\" width=\"400\">$header</td>\n"; 
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"80\">" . (($nextMonth == "") ? "&nbsp;" : "<a class=\"textlink\" href=\"$nextMonth\">&nbsp;&gt;&gt;</a>")  . "</td>\n";
    	$s .= "</tr>\n";    	
    	$s .= "<tr>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"10\">" . $this->dayNames[($this->startDay+1)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"10\">" . $this->dayNames[($this->startDay+2)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"10\">" . $this->dayNames[($this->startDay+3)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"10\">" . $this->dayNames[($this->startDay+4)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\" width=\"10\">" . $this->dayNames[($this->startDay+5)%7] . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+6)%7] . "</td>\n";
    	$s .= "</tr>\n";
    	
    	$d = $this->startDay + 1 - $first;
    	while ($d > 1)
    	{
    	    $d -= 7;
    	}

        $today = getdate(time());
    	
    	while ($d <= $daysInMonth)
    	{
    	    $s .= "<tr>\n";       
    	    
    	    for ($i = 0; $i < 7; $i++)
    	    {
    	        if ($d > 0 && $d <= $daysInMonth)
    	        {				
	        	    $class = $this->getClass($d, $month, $year);			
					$style = $this->getStyle($d, $month, $year);			
	    	        $s .= "<td class=\"$class\" $style align=\"center\" valign=\"top\" height=\"20\">";       
    			} else {
 	        	    $class = ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"]) ? "calendarToday" : "calendarDate";	
					$s .= "<td class=\"$class\" align=\"center\" valign=\"top\" height=\"20\">";  

				}
    	        if ($d > 0 && $d <= $daysInMonth)
    	        {				
					$link = $this->getDateLink($d, $month, $year, $class);
					$eday = $this->getDateInfo($d, $month, $year);
					$event = $this->getEvent($d, $month, $year);
    	            $s .= (($link == "") ? $d : "$link$eday</a><div id=\"$d\" style=\"display:none; width:150px; position:absolute; border:1px solid #FFFFFF; background:#CDCDCD; padding:15px;\">$event</div>");
    	        }
    	        else
    	        {
    	            $s .= "&nbsp;";
    	        }
      	        $s .= "</td>\n";       
        	    $d++;
    	    }
    	    $s .= "</tr>\n";    
    	}
    	
    	$s .= "</table>\n";	
    	return $s;  	
    }
    
    
    function adjustDate($month, $year)
    {
        $a = array();  
        $a[0] = $month;
        $a[1] = $year;
        
        while ($a[0] > 12)
        {
            $a[0] -= 12;
            $a[1]++;
        }
        
        while ($a[0] <= 0)
        {
            $a[0] += 12;
            $a[1]--;
        }
        
        return $a;
    }

    var $startDay = 0;

    var $startMonth = 1;

    var $dayNames = array("S", "M", "T", "W", "T", "F", "S");
    
    var $monthNames = array("January", "February", "March", "April", "May", "June",
                            "July", "August", "September", "October", "November", "December");
                                                       
    var $daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
    
}

$d = getdate(time()); 

if (isset($_POST['select_month'])) {
	$month = (isset($_POST['select_month']) && $_POST['select_month'] != 0) ? $_POST['select_month'] : $d["mon"]; 
	} else {
	$month = (isset($_GET['month']) && $_GET['month'] != '') ? $_GET['month'] : $d["mon"]; 
	}
if (isset($_POST['select_month'])) {
	$year = (isset($_POST['select_year']) && $_POST['select_year'] != 0) ? $_POST['select_year'] : $d["year"];
	} else {
	$year = (isset($_GET['year']) && $_GET['year'] != '') ? $_GET['year'] : $d["year"];
	}
	
$cal = new Calendar; 

echo $cal->getCurrentMonthView($month, $year);

?>